﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using System.Collections.Generic;


public partial class StoredProcedures
{
    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void RowCounter()
    {
        Dictionary<string, int> typeDictionary = new Dictionary<string, int>();
        using (SqlConnection connection = new SqlConnection("context connection=true"))
        {
            connection.Open();
            using (SqlCommand command = new SqlCommand("SELECT [type] from [sys].[objects];", connection))
            {
                using (SqlDataReader reader = command.ExecuteReader())
                {
                    while (reader.Read())
                    {
                        string type = reader.GetString(0);
                        if (typeDictionary.ContainsKey(type))
                        {
                            typeDictionary[type] = typeDictionary[type] + 1;
                        }
                        else
                        {
                            typeDictionary.Add(type, 1);
                        }
                    }
                }
            }
        }

        SqlDataRecord record =
            new SqlDataRecord(new SqlMetaData[] {
                    new SqlMetaData("Type", SqlDbType.NChar, 2),
                    new SqlMetaData("Count", SqlDbType.Int)
                });
        SqlContext.Pipe.SendResultsStart(record);
        foreach (KeyValuePair<string, int> kvp in typeDictionary)
        {
            record.SetString(0, kvp.Key);
            record.SetInt32(1, kvp.Value);
            SqlContext.Pipe.SendResultsRow(record);
        }
        SqlContext.Pipe.SendResultsEnd();
    }
};
