﻿using System;
using System.Data;
using System.Data.SqlClient;
using Microsoft.SqlServer.Server;
using System.Data.SqlTypes;
using System.Xml;


public partial class Triggers
{
    [Microsoft.SqlServer.Server.SqlTrigger(Target = "DATABASE",
                                            Event = "FOR CREATE_TABLE")]
    public static void TestDDLTrigger()
    {
        XmlDocument document = new XmlDocument();
        document.LoadXml(SqlContext.TriggerContext.EventData.Value);

        string objectName = document.SelectSingleNode("//SchemaName").InnerText + "." +
                            document.SelectSingleNode("//ObjectName").InnerText;
        SqlContext.Pipe.Send("Table " + objectName + " was created.");
    }
}
